%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% precstat.pl : funcions de tractament de precedncia i status. (03-09-02)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% USES : list
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% generarF(Constprec, Prec,PrecOut,Stat,StatOut).
% check_stat(F,G,Stat,Ans)
% close_stat(Prec,Stat,StatOut,[F,S])
% quin_stat(F,Stat,StatF) 
% igual(F,G,Prec)
% rel(F,G,Prec)
% fer_iguals_tops(F,G,Prec,Stat,Prec,Stat)
% exist_prec_g_ge_eq(F,G,Prec)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

generarF(F>=F,P,P,S,S):-!.
generarF(F>=G,Prec1,_,_,_):-member212(G>F,Prec1),!,fail.
generarF(F>=G,Prec1,Prec1,S,S):-member212(F>=G,Prec1),!.
generarF(F>=G,Prec1,Prec1,S,S):-member212(F>G,Prec1),!.
generarF(F>=G,Prec1,Prec1,S,S):-member212(F=G,Prec1),!.
generarF(F>=G,Prec1,Prec1,S,S):-member212(G=F,Prec1),!.
generarF(F>=G,Prec1,PrecS,Stat,StatOut):-
	member212(G>=F,Prec1),!, sort([F,G],[F1,G1]),
	check_stat(F,G,Stat,Symb_Stat),
	new_closure(F1=G1,Prec1,PrecS),
	((Symb_Stat=no,StatOut=Stat);(close_stat(PrecS,Stat,StatOut,Symb_Stat))),!.
generarF(F>=G,Prec1,PrecS,S,S):-new_closure(F>=G,Prec1,PrecS),!.
	
generarF(F>F,_,_,_,_):-!,fail.
generarF(F>G,Prec1,_,_,_):-member212(G>F,Prec1),!,fail.
generarF(F>G,Prec1,_,_,_):-member212(G=F,Prec1),!,fail.
generarF(F>G,Prec1,_,_,_):-member212(F=G,Prec1),!,fail.
generarF(F>G,Prec1,_,_,_):-member212(G>=F,Prec1),!,fail.
generarF(F>G,Prec1,Prec1,S,S):-member212(F>G,Prec1),!.
generarF(F>G,Prec1,PrecS,S,S):-new_closure(F>G,Prec1,PrecS),!.

generarF(F=F,P,P,S,S):-!.
generarF(F=G,Prec1,_,_,_):-member212(G>F,Prec1),!,fail.
generarF(F=G,Prec1,_,_,_):-member212(F>G,Prec1),!,fail.
generarF(F=G,Prec1,Prec1,S,S):-member212(F=G,Prec1),!.
generarF(F=G,Prec1,Prec1,S,S):-member212(G=F,Prec1),!.
generarF(F=G,Prec1,PrecS,Stat,StatOut):-	
	check_stat(F,G,Stat,Symb_Stat),
	sort([F,G],[F1,G1]),
	new_closure(F1=G1,Prec1,PrecS),
	((Symb_Stat=no,StatOut=Stat);(close_stat(PrecS,Stat,StatOut,Symb_Stat))),!.

new_closure(NewP,Prec,PrecSS):-
	NewP=..[_|[F,G]],
	separate([F,G],Prec,[],PrecFG,PrecOthers),
	newclose(NewP,PrecFG,PrecFGclose),
	concat312(PrecFGclose,PrecOthers,PrecS),
	sort(PrecS,PrecSS),!.

%%%%%%

separate(L,Prec,PrecL0,PrecL,PrecOthers):-
	delete33(P,Prec,Prec1),
	P=..[_|Ops],
	some_in(Ops,L),!,
%	difer(Ops,L,Nous),
%	concat312(Nous,L,L1),
	unio1(Ops,L,L1),
	separate(L1,Prec1,[P|PrecL0],PrecL,PrecOthers).
separate(_,Prec,PrecL,PrecL,Prec):-!.


some_in([F|_],L):-member212(F,L),!.
some_in([_|Rest],L):-some_in(Rest,L),!.

%%%%%%

newclose(F>G,Prec,PrecOut):-
	obt_g_ge_eq_S(F,Prec,LF),
	obt_l_le_eq_S(G,Prec,LG),
	prodall('>',LF,LG,[],Prec1),
	concat312(Prec,Prec1,Prec2),
	redund(Prec2,PrecOut).

newclose(F=G,Prec,PrecOut):-
	obt_eq_S(F,Prec,LigF),
	obt_eq_S(G,Prec,LigG),
	prodall('=',LigF,LigG,[],NPrec1),
	obt_in_ge_ge(F,G,Prec,Prec1,NousIgFG),	%esborrant de Prec
	prodall('=',NousIgFG,NousIgFG,NPrec1,NPrec2),
	concat312(LigF,LigG,LigFG),
	prodall('=',LigFG,NousIgFG,NPrec2,NPrec3),
	concat312(LigFG,NousIgFG,AllIgFG),
	obt_gr_l_S([F,G],Prec1,Prec2,LgrFG,LlFG),  % esborrant (impossible que estiguin a AllIgFG
	concat312(LgrFG,LlFG,L1),
	concat312(AllIgFG,L1,L2),
	obt_ge_le_S([F,G],Prec2,Prec3,LgeFG,LleFG,L2),  
			% ge i le que no estiguin a L2 i esborrant
	concat312(AllIgFG,LlFG,A1),
	concat312(A1,LleFG,A2),
	prodall('>',LgrFG,A2,NPrec3,NPrec4),
	prodall('>=',LgeFG,A2,NPrec4,NPrec5),
	concat312(LgeFG,AllIgFG,B1),
	prodall('>',B1,LlFG,NPrec5,NPrec6),
	prodall('>=',B1,LleFG,NPrec6,NPrec7),!,
	concat312(Prec3,NPrec7,NPrec),
	redund(NPrec,PrecOut).
	

newclose(F>=G,Prec,PrecOut):-
	obt_g_ge_eq_S(F,Prec,LesqF),
	obt_l_le_eq_S(G,Prec,LdretG),
	obt_gr_F(F,Prec,LgrF),
	prodall('>',LgrF,LdretG,[],NPrec1),
	obt_F_gr(G,Prec,LGgr),
	prodall('>',LesqF,LGgr,NPrec1,NPrec2),
	difer(LesqF,LgrF,LrestF),
	difer(LdretG,LGgr,LrestG),
	prodall('>=',LrestF,LrestG,NPrec2,NPrec3),
	concat312(Prec,NPrec3,NPrec),
	redund(NPrec,PrecOut),!.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% per F>=G

obt_gr_F(_,[],[]):-!.
obt_gr_F(F,[H>F|Prec],[H|LgrF]):-!,
	obt_gr_F(F,Prec,LgrF),!.
obt_gr_F(F,[_|Prec],LgrF):-
	obt_gr_F(F,Prec,LgrF),!.

obt_F_gr(_,[],[]):-!.
obt_F_gr(F,[F>H|Prec],[H|LgrF]):-!,
	obt_F_gr(F,Prec,LgrF),!.
obt_F_gr(F,[_|Prec],LgrF):-
	obt_F_gr(F,Prec,LgrF),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% per F>G i F>=G

obt_g_ge_eq_S(F,[],[F]):-!.
obt_g_ge_eq_S(F,[P|Prec],[H|LF]):-
	(P=..[_|[H,F]];P=..[=|[F,H]]),!,
	obt_g_ge_eq_S(F,Prec,LF),!.
obt_g_ge_eq_S(F,[_|Prec],LF):-
	obt_g_ge_eq_S(F,Prec,LF),!.
	
obt_l_le_eq_S(F,[],[F]):-!.
obt_l_le_eq_S(F,[P|Prec],[H|LF]):-
	(P=..[_|[F,H]];P=..[=|[H,F]]),!,
	obt_l_le_eq_S(F,Prec,LF),!.
obt_l_le_eq_S(F,[_|Prec],LF):-
	obt_l_le_eq_S(F,Prec,LF),!.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% per F=G

obt_eq_S(F,[],[F]):-!.
obt_eq_S(F,[F=G|Prec],[G|LigF]):-!,
	obt_eq_S(F,Prec,LigF),!.
obt_eq_S(F,[G=F|Prec],[G|LigF]):-!,
	obt_eq_S(F,Prec,LigF),!.
obt_eq_S(F,[_|Prec],LigF):-
	obt_eq_S(F,Prec,LigF),!.

%%%%%%%%%%
obt_in_ge_ge(F,G,Prec,PrecOut,NousIgFG):-
	obt_in_ge_ge1(F,G,Prec,[],L),
	obt_in_ge_ge1(G,F,Prec,L,NousIgFG),!,
	simpl_ge_ge(F,G,Prec,NousIgFG,PrecOut),!.

	
obt_in_ge_ge1(_,_,[],N,N):-!.
obt_in_ge_ge1(F,G,[F>=H|Prec],IgFG,NousIgFG):-
	member22(H>=G,Prec),!,
	obt_in_ge_ge1(F,G,Prec,[H|IgFG],NousIgFG).
obt_in_ge_ge1(F,G,[H>=G|Prec],IgFG,NousIgFG):-
	member22(F>=H,Prec),!,
	obt_in_ge_ge1(F,G,Prec,[H|IgFG],NousIgFG).
obt_in_ge_ge1(F,G,[_|Prec],IgFG,NousIgFG):-
	obt_in_ge_ge1(F,G,Prec,IgFG,NousIgFG).
	
simpl_ge_ge(_,_,[],_,[]):-!.
simpl_ge_ge(F,G,[P|Prec],L,PrecOut):-
	( P=..[>=|[K,H]] ; P=..[>=|[H,K]] ),
	( K=F ; K=G ),
	member22(H,L),!,
	simpl_ge_ge(F,G,Prec,L,PrecOut),!.
simpl_ge_ge(F,G,[P|Prec],L,[P|PrecOut]):-
	simpl_ge_ge(F,G,Prec,L,PrecOut),!.

%%%%%%%%%%

obt_gr_l_S(_,[],[],[],[]):-!.
obt_gr_l_S([F,G],[H>K|Prec],PrecOut,[H|LgrFG],LlFG):-
	(K=F;K=G),!,
	obt_gr_l_S([F,G],Prec,PrecOut,LgrFG,LlFG),!.
obt_gr_l_S([F,G],[K>H|Prec],PrecOut,LgrFG,[H|LlFG]):-
	(K=F;K=G),!,
	obt_gr_l_S([F,G],Prec,PrecOut,LgrFG,LlFG),!.
obt_gr_l_S([F,G],[P|Prec],[P|PrecOut],LgrFG,LlFG):-
	obt_gr_l_S([F,G],Prec,PrecOut,LgrFG,LlFG),!.


obt_ge_le_S(_,[],[],[],[],_):-!.
obt_ge_le_S([F,G],[H>=K|Prec],PrecOut,LgeFG,LleFG,Symbs):-
	(K=F;K=G),
	member212(H,Symbs),!,
	obt_ge_le_S([F,G],Prec,PrecOut,LgeFG,LleFG,Symbs),!.
obt_ge_le_S([F,G],[H>=K|Prec],PrecOut,[H|LgeFG],LleFG,Symbs):-
	(K=F;K=G),!,
	obt_ge_le_S([F,G],Prec,PrecOut,LgeFG,LleFG,Symbs),!.
obt_ge_le_S([F,G],[K>=H|Prec],PrecOut,LgeFG,LleFG,Symbs):-
	(K=F;K=G),
	member212(H,Symbs),!,
	obt_ge_le_S([F,G],Prec,PrecOut,LgeFG,LleFG,Symbs),!.
obt_ge_le_S([F,G],[K>=H|Prec],PrecOut,LgeFG,[H|LleFG],Symbs):-
	(K=F;K=G),!,
	obt_ge_le_S([F,G],Prec,PrecOut,LgeFG,LleFG,Symbs),!.
obt_ge_le_S([F,G],[P|Prec],[P|PrecOut],LgrFG,LlFG,Symbs):-
	obt_ge_le_S([F,G],Prec,PrecOut,LgrFG,LlFG,Symbs),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

prodall(_,[],_,P,POut):-!,sort(P,POut).
prodall(Op,[F|RF],LG,Prec,PrecOut):-
	((Op='=',prodeq1(F,LG,Prec,Prec1));
	  prod1(Op,F,LG,Prec,Prec1)),
	prodall(Op,RF,LG,Prec1,PrecOut),!.

prod1(_,_,[],Prec,Prec):-!.
prod1(Op,F,[H|Rest],Prec,PrecOut):-
	P=..[Op|[F,H]],
	prod1(Op,F,Rest,[P|Prec],PrecOut),!.

prodeq1(_,[],Prec,Prec):-!.
prodeq1(F,[H|Rest],Prec,PrecOut):-
	F==H,!,
	prodeq1(F,Rest,Prec,PrecOut),!.
prodeq1(F,[H|Rest],Prec,PrecOut):-
	sort([F,H],[F1,H1]),
	prodeq1(F,Rest,[F1=H1|Prec],PrecOut),!.

%%%%%%%%%

prodgeall(_,_,[],[]):-!.
prodgeall(F,G,[P|Prec],[H>=G|PFGOut]):-
	(P=..[=|[F,H]];P=..[=|[H,F]]),!,
	prodgeall(F,G,Prec,PFGOut),!.
prodgeall(F,G,[P|Prec],[F>=H|PFGOut]):-
	(P=..[=|[G,H]];P=..[=|[H,G]]),!,
	prodgeall(F,G,Prec,PFGOut),!.
prodgeall(F,G,[G>=H|Prec],[F>=H|PFGOut]):-!, 
	prodgeall(F,G,Prec,PFGOut),!.
prodgeall(F,G,[H>=F|Prec],[H>=G|PFGOut]):-!, 
	prodgeall(F,G,Prec,PFGOut),!.
prodgeall(F,G,[G>H|Prec],[F>H|PFGOut]):-!, 
	prodgeall(F,G,Prec,PFGOut),!.
prodgeall(F,G,[H>F|Prec],[H>G|PFGOut]):-!, 
	prodgeall(F,G,Prec,PFGOut),!.
prodgeall(F,G,[_|Prec],Prec1):-
	prodgeall(F,G,Prec,Prec1),!.

	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
redund(P,POut):-
	elimtriv(P,P1),!,
	redund1(P1,POut),!.

elimtriv(P,POut):-
	delete32(F>=F,P,P1),!,
	elimtriv(P1,POut).
elimtriv(P,POut):-
	delete32(F=F,P,P1),!,
	elimtriv(P1,POut).
elimtriv(P,P):-!.


redund1(P,POut):-
	delete33(F>=G,P,P1),
  	(member22(F>G,P);
	 (member22(F=G,P);member22(G=F,P))),	
	redund1(P1,POut),!.
redund1(P,P):-!.


%%%%%%%%%%%%%%

closeall([],Prec,Prec):-!.
closeall([N|New],Prec,PrecOut):-
	member22(N,Prec),!,
	closeall(New,Prec,PrecOut),!.
closeall([N|New],Prec,PrecOut):-
	newclose(N,Prec,Prec1),!,
	closeall(New,Prec1,PrecOut),!.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

check_stat(F,G,Stat,no):-
	member21([F,StatF],Stat),
	member21([G,StatG],Stat),!,
	StatF=StatG,!.
check_stat(F,_,Stat,[F,StatF]):-
	member21([F,StatF],Stat),!.
check_stat(_,G,Stat,[G,StatG]):-
	member21([G,StatG],Stat),!.
check_stat(_,_,_,no):-!.
	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
close_stat(Prec,Stat,StatOut,[F,S]):-
	obt_symbs_iguals(F,Prec,[F],Lsymbs),
	addStatifno(S,Lsymbs,Stat,StatOut),!.

obt_symbs_iguals(_,[],LSymbs,LSymbsOut):-sort(LSymbs,LSymbsOut),!.
obt_symbs_iguals(F,[F=G|Prec],LSymbs0,LSymbsOut):-!,
	obt_symbs_iguals(F,Prec,[G|LSymbs0],LSymbsOut),!.
obt_symbs_iguals(F,[G=F|Prec],LSymbs0,LSymbsOut):-!,
	obt_symbs_iguals(F,Prec,[G|LSymbs0],LSymbsOut),!.
obt_symbs_iguals(F,[_|Prec],LSymbs0,LSymbsOut):-
	obt_symbs_iguals(F,Prec,LSymbs0,LSymbsOut),!.

addStatifno(_,[],Stat,Stat):-!.
addStatifno(S,[F|Lsymbs],Stat,StatOut):-
	addifno([F,S],Stat,Stat1),!,
	addStatifno(S,Lsymbs,Stat1,StatOut),!.
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

quin_stat(F,Stat,mul):-member212([F,mul],Stat),!.
quin_stat(F,Stat,lex):-member212([F,lex],Stat),!.
quin_stat(F,Stat,lexr):-member212([F,lexr],Stat),!.
quin_stat(_,_,cap).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

igual(F,F,_):-!.
igual(F,G,Prec):- 
	sort([F,G],[A,B]),
	member212(A=B, Prec),!.

rel(F,F,_):-!.
rel(F,G,Prec):-
	member22(P,Prec),
	(P=..[_|[F,G]];	P=..[_|[G,F]]),!.	



fer_iguals_tops(F,G,Prec,Stat,Prec,Stat):-
	igual(F,G,Prec),!.
fer_iguals_tops(F,G,Prec,Stat,PrecOut,StatOut):-
	generarF(F=G,Prec,PrecOut,Stat,StatOut),!.


exist_prec_g_ge_eq(F,F,_):-!.
exist_prec_g_ge_eq(F,G,Prec):- 
	sort([F,G],[F1,G1]), member212(F1=G1,Prec),!.
exist_prec_g_ge_eq(F,G,Prec):- member212(F>G,Prec),!.
exist_prec_g_ge_eq(F,G,Prec):- member212(F>=G,Prec),!.


