%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% messages.pl  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% mostrar la demostraci
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mostrar_demostracio(Rules,Proof,Res):-
	simplif_rules_strat(Rules,Rules1),
	((Rules=Rules1,!)
	  ;
	 ( difer(Rules,Rules1,RulesElim),
	   renvars_list1(RulesElim,RulesE),
	   miss_elim_rules(RulesE),nl
	 )
	),!,	   
	mostrar_demo(Rules1,Proof,Res),!.


miss_elim_rules([Rule]):-!,
	   write('Using innermost rewriting the following rule can be eliminated:'),nl,nl,
   	   write_Rules([Rule]),nl,!.
miss_elim_rules(Rules):-!,
	   write('Using innermost rewriting the following rules can be eliminated:'),nl,nl,
   	   write_Rules(Rules),nl,!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Quan el resultat s que NO ho sabem demostrar 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%quan no s'aplica modularitat
mostrar_demo(Rules,_,['no']):-!,
	renvars_list1(Rules,Rules1),
	show_message(['no'],Rules1),!.
%quan s'aplica modularitat i tenim un nic sistema
mostrar_demo(Rules,_,['mod',[['n','no',SymbsBase]]]):-!,
	selec_rules_group(SymbsBase,Rules,RulesG),
	renvars_list1(RulesG,RulesG1),
	show_message(['nomod'],RulesG1),!.
% Considerem Modularitat i tenim varis sistemes i algun falla.
mostrar_demo(Rules,_,['mod',Resultats]):-
	renvars_list1(Rules,Rules1),
	last(Resultats,['n','no',SymbsBase]),!,		
	selec_rules_group(SymbsBase,Rules1,RulesG),
	write('The system is '),nl,nl,
	write_Rules(Rules1),nl,
	show_message(['nomod'],RulesG),!.
mostrar_demo(Rules,_,['mod',Resultats]):-
	renvars_list1(Rules,Rules1),
	last(Resultats,['m','no',SymbsBase,SymbsHier]),!,		
	selec_rules_group(SymbsHier,Rules1,RulesH),
	difer(SymbsBase,SymbsHier,RestSymbs),
	selec_rules_group(RestSymbs,Rules1,RulesB),
	write('The system is '),nl,nl,
	write_Rules(Rules1),nl,
	concat312(RulesB,[[]|RulesH],RulesOut),
	show_message(['nomod'],RulesOut),!.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Quan TENIM SOLUCI 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Tenim varis sistemes
mostrar_demo(Rules,Proof,['mod',Resultats]):-!,
	Resultats=[_,_|_], %tenim ms d'un sistema
	renvars_list1(Rules,Rules1),
	write('The system is '),nl,nl,
	write_Rules(Rules1),nl,
	write('*******************************************************'),nl,
	write('*****  Using modularity results we can prove the  *****'),nl,
	write('*****    termination of the system as follows:    *****'),nl,
	write('*******************************************************'),nl,nl,
	mostrar_demostracio_cada_sistema(1,Rules,Proof,Resultats),!.

% provavem modularitat i tenim un sol sistema
mostrar_demo(_,['mod',[['n','yes']]]):-
	show_message(['yes'],_),nl,!.
mostrar_demo(Rules,Proof,['mod',[ResPositiu]]):-!,
	mostrar_demostracio_cada_sistema(0,Rules,Proof,[ResPositiu]),!.

% tenim un sol sistema i no provavem modularitat
mostrar_demo(_,_,['yes']):-
	show_message(['yes'],_),nl,!.
mostrar_demo(Rules,Proof,ResPositiu):-
	mostrar_demostracio_cada_sistema(0,Rules,[Proof],[ResPositiu]),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Rules cont totes les regles del sistema amb variables
%RulesB cont totes les regles del subsistema enumerades i amb variables
% QIndepSubgraphs=[S1,S2,...], Cas normal : S1=[Q,Lstr,Lnostr](cas normal) 
% Cas deeper o inner S1=[Q,Lstr,Lnostr,a1/a2] o [Q,Lstr,Lnostr,[Lcond,Lcancel,[a1,a2,...]]] 
mostrar_demostracio_cada_sistema(_,_,[],[]):-!.
mostrar_demostracio_cada_sistema(NumSys,Rules,[[RulesB,CamiIni,ConstIniSimpl,[Def,V,QIndepSubgraphs]]|ProofRest],[['n','siMB',Resultat]|Rest]):-!,
	renvars_list1(RulesB,RulesB1),
	map(snd2,RulesB1,RulesOut),
	mostra_sistema(NumSys,NumSysNew,RulesOut),
	mostra_constraint_inicial(RulesB1,CamiIni,ConstIni),
	( ( ConstIni=[],!, miss_si(1) )
	  ;
	  ( ((difer(ConstIni,ConstIniSimpl,[]),!,
	      mostra_constraint_1a_simplif(ConstIniSimpl,igual)
	     )
	     ;
	     mostra_constraint_1a_simplif(ConstIniSimpl,noigual)
	    ),
	    map(snd2,RulesB,RulesBnoEnum),
	    obtenir_nums_a1_b(QIndepSubgraphs,LnumsSteps),
	    mostrar_simplif_nf_i_pasreescr(Def,V,RulesBnoEnum,ConstIniSimpl,LnumsSteps),
	    mostra_resta_demostracio(RulesOut,QIndepSubgraphs,Resultat),!,nl
	  )
	),!,
	mostrar_demostracio_cada_sistema(NumSysNew,Rules,ProofRest,Rest),!.
	

%Rules cont totes les regles del sistema amb variables
%RulesH cont totes les regles de l'enriquiment en unions jerrquiques enumerades i amb variables
mostrar_demostracio_cada_sistema(NumSys,Rules,[[RulesH,CamiIni,ConstIniSimpl,[Def,V,QIndepSubgraphs]]|ProofRest],[['m','siMH',Sbase,Shier,Resultat]|Rest]):-!,
	map(snd2,RulesH,RulesHnoEnum),
	difer(Sbase,Shier,RestSymbs),
	selec_rules_group(RestSymbs,Rules,RulesB),
	concat312(RulesB,[[]|RulesHnoEnum],Rulessystem),
	renvars_list1(Rulessystem,RulesOut),
	mostra_sistema(NumSys,NumSysNew,RulesOut),
	renvars_list1(RulesH,RulesHgr),
	mostra_constraint_inicial(RulesHgr,CamiIni,ConstIni),
	( (ConstIni=[],!, miss_si(1) )
	  ;
	  (((difer(ConstIni,ConstIniSimpl,[]),!,
	     mostra_constraint_1a_simplif(ConstIniSimpl,igual)
	    );
	    mostra_constraint_1a_simplif(ConstIniSimpl,noigual)
	   ),
	   concat312(RulesB,RulesHnoEnum,Rulessystem1),
	   obtenir_nums_a1_b(QIndepSubgraphs,LnumsSteps),
	   mostrar_simplif_nf_i_pasreescr(Def,V,Rulessystem1,ConstIniSimpl,LnumsSteps),
	   mostra_resta_demostracio(RulesOut,QIndepSubgraphs,Resultat),nl
	  )
	),!,
	mostrar_demostracio_cada_sistema(NumSysNew,Rules,ProofRest,Rest),!.



%QUAN NO S'APLICA MODULARITAT -- un nic sistema
%Rules cont totes les regles del sistema amb variables
%RulesE cont totes les regles del sistema amb variables i enumerades
mostrar_demostracio_cada_sistema(NumSys,_,[[RulesE,CamiIni,ConstIniSimpl,[Def,V,QIndepSubgraphs]]],[Resultat]):-
	renvars_list1(RulesE,RulesE1),
	map(snd2,RulesE1,RulesOut),
	mostra_sistema(NumSys,_,RulesOut),
	mostra_constraint_inicial(RulesE1,CamiIni,ConstIni),
	( ( ConstIni=[],!, miss_si(1) )
	  ;
	  ( ((difer(ConstIni,ConstIniSimpl,[]),!,
	      mostra_constraint_1a_simplif(ConstIniSimpl,igual)
	     )
	     ;
	     mostra_constraint_1a_simplif(ConstIniSimpl,noigual)
	    ),
	    map(snd2,RulesE,RulesEnoEnum),
	    obtenir_nums_a1_b(QIndepSubgraphs,LnumsSteps),
	    mostrar_simplif_nf_i_pasreescr(Def,V,RulesEnoEnum,ConstIniSimpl,LnumsSteps),
	    mostra_resta_demostracio(RulesOut,QIndepSubgraphs,Resultat),nl
	  )
	),!.

	
% Per saber per quins subgraphs cal mostrar condicions
obtenir_nums_a1_b([],[]):-!.
obtenir_nums_a1_b([[Q,_,_,K]|QIndepSubgraphs],LnumsSteps):-
	((K=a1;K=[_|_])),!,
	map(selnumQ,Q,L1),
	obtenir_nums_a1_b(QIndepSubgraphs,Lnums1),
	concat312(L1,Lnums1,LnumsSteps),!.
obtenir_nums_a1_b([_|QIndepSubgraphs],LnumsSteps):-
	obtenir_nums_a1_b(QIndepSubgraphs,LnumsSteps),!.


%si Def=[] vol dir no try_cancel_cycles (no innermost i no deeper)
mostrar_simplif_nf_i_pasreescr([],_,_,_,_):-!.
mostrar_simplif_nf_i_pasreescr(Def,V,Rules,Q,Lnums):-
	retractall(variables(_)),
	assert(variables(V)),
	convert(Q,Q0),
	rentops_i_enum(Q0,1,Q1),
	conv_cts_vars(Q1,Qvars),
	abstraction(Qvars,Def,Qabs),
	obtain_graph_and_cancelled_connexions(Rules,Qabs,Subgraphs,LnoconnNF),
	obtain_cancel_and_step_each_subgraph(Rules,Def,Subgraphs,LcancelNF,LcancelNoStep,LcycStep,Lnums),
	mostrar_cancelacions_i_simpl(LnoconnNF,LcancelNF,LcancelNoStep,LcycStep,Q1),!.

mostrar_cancelacions_i_simpl([],[],[],[],_):-!.
mostrar_cancelacions_i_simpl(LnoConnNF,LcancelNF,LcancelNoStep,LcycStep,Q):-
	write('------------------------------------------------------------------------'),nl,
	((innermost,!,Mess='Some explanations about the potencial cycles in the innermost graph obtained from:')
	 ;
	 (Mess='Some explanations about the potencial cycles in the graph obtained from:')	
	),
	write(Mess),nl,
	mostra_Q1(Q),nl,
	mostrar_noconnexions_nf(LnoConnNF),
	mostrar_cancelats_nf(LcancelNF),
	mostrar_cancelats_noStep(LcancelNoStep),
	mostrar_cicles_Step(LcycStep),
	write('------------------------------------------------------------------------'),nl,nl,!.


mostra_resta_demostracio(_,_,[triv1]):-!.
mostra_resta_demostracio(_,_,[triv2,_]):-
 %	write('Now the top symbol of the constraints is renamed.'),nl,
 %	write_list(5,C),
	miss_si(2),nl,!.
mostra_resta_demostracio(_,_,[triv3]):-!,
%	write('Now the top symbol of the constraints is renamed.'),nl,
%	write_list(5,Q),
%	miss_si(2),nl,!.
        write('There are no potential cycles to consider.'),nl,!.		
%mostra_resta_demostracio(Rules,_,_,[Q,LCycles],[triv3,_]):-
%	write('Now the top symbol of the constraints is renamed.'),nl,
%	mostra_tots_els_cicles(Q,LCycles),
%	proof_simplify_inner(Rules,[Q,LCycles],_,_),	
%       write('Therefore, there are no potential cycles to consider.'),nl,!.	
mostra_resta_demostracio(RulesOut,[QIndepSubgraphs],[Type,[Res]]):-!,
	convert_rules_const(RulesOut,C_Rules),
	write('%%%%% Computing the graph we obtain: %%%%%'),nl,nl,
	mostrar_subgraph_indep_i_resultat(C_Rules,QIndepSubgraphs,Type,Res),!.		
mostra_resta_demostracio(RulesOut,QIndepSubgraphs,[Type,Res]):-	
	nl,write('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),nl,
	write('%%%%%  We can prove separatedly the following subsystems: %%%%%'),nl,
	write('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),nl,nl,
	convert_rules_const(RulesOut,C_Rules),
	mostrar_subgraphs_independents_i_resultat(C_Rules,QIndepSubgraphs,Type,Res),!.


mostrar_subgraphs_independents_i_resultat(_,[],_,[]):-!.
mostrar_subgraphs_independents_i_resultat(C_Rules,[SubProof|QIndepSubgraphs],Type,[Res|Resultats]):-
	nl,write('*******************************************'),
	nl,write('************** The subsystem **************'),
	nl,write('*******************************************'),nl,nl,
	mostrar_subgraph_indep_i_resultat(C_Rules,SubProof,Type,Res),!,		
	mostrar_subgraphs_independents_i_resultat(C_Rules,QIndepSubgraphs,Type,Resultats),!.


mostrar_subgraph_indep_i_resultat(CRules,[Q,LStr,LNoStr],'si1',Res):-
	mostrar_constraint_i_cicles(Q,LStr,LNoStr,'a1'),
	mostra_result_Sub('si1',CRules,Res),!.
mostrar_subgraph_indep_i_resultat(CRules,[Q,LStr,LNoStr,K],Type,Res):-
	( K='a1' ; K='a2' ),!,
	mostrar_constraint_i_cicles(Q,LStr,LNoStr,K),
	mostra_result_Sub(Type,CRules,Res),!.
mostrar_subgraph_indep_i_resultat(CRules,[Q,LStr,LNoStr,[Lcond,Lcancyc,[]]],Type,[Res]):-!,
	mostrar_constraint_i_cicles(Q,LStr,LNoStr,'a1'),
	mostrar_Lcond_cancel_no_subgraphs(Lcond,Lcancyc),
	mostra_result_Sub(Type,CRules,Res),!.
mostrar_subgraph_indep_i_resultat(CRules,[Q,LStr,LNoStr,[Lcond,Lcancyc,ProofSubg]],Type,Res):-
	mostrar_constraint_i_cicles(Q,LStr,LNoStr,'a1'),
	mostrar_Lcond_cancel_subgraphs(Lcond,Lcancyc,Q,ProofSubg,Type,CRules,Res),!.

mostrar_Lcond_cancel_no_subgraphs(Lcond,Lcancyc):-
	m_Lcond_Lcan(Lcond,Lcancyc),
	write('and recomputing the graph, there are no more potential cycles to consider'),nl,!.

m_Lcond_Lcan([L>=R],Lcancyc):-!,	
	write('If  '), 
	write(L),write(' ->* '),write(R), 
	write('  is not satisfiable,'),nl, 
	write('the following potencial cycles are cancelled:'),nl,
	l_concat(Lcancyc,Lcancyc1),
	mostra_num_and_cond_cicles(Lcancyc1),nl,!.
m_Lcond_Lcan(Lconds,Lcancyc):-	
	write('If any of the following conditions '),
	mostra_condicions_ge(Lconds),
	write('is not satisfiable, the following potencial cycles are cancelled:'),nl,
	l_concat(Lcancyc,Lcancyc1),
	mostra_num_and_cond_cicles(Lcancyc1),nl,!.


mostrar_Lcond_cancel_subgraphs(Lcond,Lcancyc,Q,[[Nums,Ls,Lns,K]],Type,CRules,[Res]):-!,
	m_Lcond_Lcan(Lcond,Lcancyc),
	write('and recomputing the graph, we obtain:'),nl,!,
	mostra_subsubgraph1(Q,Nums,Ls,Lns,K),
	mostra_result_Sub(Type,CRules,Res),!.
mostrar_Lcond_cancel_subgraphs(Lcond,Lcancyc,Q,ProofSubgs,Type,CRules,Res):-
	m_Lcond_Lcan(Lcond,Lcancyc),
	write('and recomputing the graph, we obtain the following independent subsystems:'),nl,
	mostra_subsubgraphs(Q,ProofSubgs,Type,CRules,Res),!.
	
         
mostra_result_Sub('si1',CRules,Res):-
	show_result_Set(CRules,Res),!.
mostra_result_Sub('si2',CRules,Res):-
	show_result_Set_cancel(CRules,Res),!.

mostra_subsubgraph1(Q,Nums,Ls,Lns,K):-
	selec_Q_Nums(Q,Nums,QNums),
	mostrar_constraint_i_cicles(QNums,Ls,Lns,K),!.		
	
selec_Q_Nums(_,[],[]):-!.
selec_Q_Nums(Q,[N|Nums],[q(N,C)|QNums]):-
	member21(q(N,C),Q),!,	
	selec_Q_Nums(Q,Nums,QNums),!.

mostra_subsubgraphs(_,[],_,_,[]):-!.
mostra_subsubgraphs(Q,[[Nums,Ls,Lns,K]|ProofSubgs],Type,CRules,[Res|Resultats]):-
	nl,write('*********** The subsystem ***********'),nl,nl,
	mostra_subsubgraph1(Q,Nums,Ls,Lns,K),
	mostra_result_Sub(Type,CRules,Res),!,
	mostra_subsubgraphs(Q,ProofSubgs,Type,CRules,Resultats),!.
	

show_result_Set_cancel(CRules,[N,C,[I,P,S]]):-!,
	show_const_cancel(CRules,N,C),nl,
	show_result(I,P,S),!.

show_result_Set(Rules,[C,I,P,S]):-!,
	show_const(Rules,C),nl,nl,
	show_result(I,P,S),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mostra_constraint_1a_simplif(ConstIniSimpl,igual):-
	write('Therefore, the set of constraints is: '),nl,
	write_list_enum(5,ConstIniSimpl),nl.
mostra_constraint_1a_simplif([],noigual):-!,
	write('Analyzing the head symbol, we remove some constraints'),nl,
	write('which cannot appear in any cycle.'),nl,
	write('All constraints are removed.'),nl.
mostra_constraint_1a_simplif(ConstIniSimpl,noigual):-
	write('Analyzing the head symbol, we remove some constraints'),nl,
	write('which cannot appear in any cycle.'),nl,nl,
	write('The constraint after this simplification is : '),nl,nl,
	write_list_enum(5,ConstIniSimpl),nl.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mostrar_constraint_i_cicles(Q,LStr,LNoStr,K):-		
	mostra_Q(Q),nl,
	transform_k(K,LStr,LNoStr,LStr1,LNoStr1),
	mostra_strict_cicles(LStr1),
	mostra_NOstrict_cicles(LNoStr1),nl,!.

transform_k('a1',LStr,LNoStr,LStr,LNoStr):-!.
transform_k('a2',LStr,LNoStr,LStr1,LNoStr1):-
	map(tail,LStr,LStr1),
	map(tail,LNoStr,LNoStr1),!.


mostra_strict_cicles([]):-!.
mostra_strict_cicles(L):-
	write('Potential cycles containing some strict constraint:'),nl,
	mostra_num_and_cond_cicles(L),!.
mostra_NOstrict_cicles([]):-!,
	write('There are no potencial cycles using only non-strict constraints.'),nl,!.
mostra_NOstrict_cicles(L):-
	write('Potential cycles using only non-strict constraints:'),nl,
	mostra_num_and_cond_cicles(L),!.


mostra_num_and_cond_cicles([]).
mostra_num_and_cond_cicles([[Lc|R]|Rest]):-
	Lc=[_|_], 
	del_repes(Lc,Lc0),
	elim_nf_var(Lc0,Lc1),Lc1=[_|_],!,
	write('** { '),mostra_nums_cicles(R),write(' }'),nl,!,
	write('   under the following conditions:'),nl,
	mostra_condicions_cycle(Lc1),nl,nl,!,
	mostra_num_and_cond_cicles(Rest),!.
mostra_num_and_cond_cicles([[Lc|R]|Rest]):-
	(Lc=[];Lc=[_|_]),!,
	write('** { '),mostra_nums_cicles(R),write(' }'),nl,!,
	mostra_num_and_cond_cicles(Rest),!.
mostra_num_and_cond_cicles([Lnums|Rest]):-
	write('** { '),mostra_nums_cicles(Lnums),write(' }'),nl,!,
	mostra_num_and_cond_cicles(Rest),!.


mostra_nums_cicles([]):-!.
mostra_nums_cicles([Num]):-!,
	write(Num),!.
mostra_nums_cicles([Num|Lnum]):-
	write(Num),write(', '),
	mostra_nums_cicles(Lnum),!.
	
	
elim_nf_var([],[]):-!.
elim_nf_var([nf(X)|R],R1):-
	is_variable(X),!,
	elim_nf_var(R,R1),!.
elim_nf_var([X|R],[X|R1]):-
	elim_nf_var(R,R1),!.


mostra_Q([]):-!.
mostra_Q([q(N,C)|R]):-
	tab(5),write(N),write(': '),write(C),nl,
	mostra_Q(R),!.

mostra_Q1([]):-!.
mostra_Q1([q(N,C,_)|R]):-
	tab(5),write(N),write(': '),write(C),nl,
	mostra_Q1(R),!.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mostra_sistema(0,0,Rules):-
	mostra_sistema(Rules),!.
mostra_sistema(N,M,Rules):-
	write('*******************************************************'),nl,
	write('*********************  System - '), write(N), write('  ********************'), nl,
	write('*******************************************************'),nl,nl,
	M is N+1,
	mostra_sistema(Rules),!.

mostra_sistema(Rules):-
	write('The set of rules is'),nl,nl,
	write_Rules(Rules),nl,!.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Reconstrueix la sequencia de MSPO codificada a Cami
% aplicada a les regles RulesEnum
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


mostra_constraint_inicial(R,Cami,ConstIniOut):-
	obte_SPO(Quin_SPO),
	write('The initial constraint obtained by applying the '),
	write(Quin_SPO), write(' is: '),nl,nl,
	mostrar_Rules_Cam(R,Cami,ConstIni),
	l_concat(ConstIni,ConstIniOut),!.

obte_SPO('SPO-lex'):-
	statuslex,!.
obte_SPO('SPO').


mostrar_Rules_Cam([],_,[]):-!.
mostrar_Rules_Cam([[N,[L,R]]|RulesEnum],Cami,[ConsIni|RestConsIni]):-
	delete32([N,CamN],Cami,Cami1),!,
	write('Rule:  '),write(L),write(' -> '),write(R),nl,
	reconstrueix(L,R,CamN,LCons,5),
	( (LCons=[],!,write('No constraints.'), nl,nl)
	  ;
	  (write('Constraints:'),nl,mostra(LCons),nl)
	),!,
	treu_tab_cons(LCons,ConsIni),
	mostrar_Rules_Cam(RulesEnum,Cami1,RestConsIni),!.

treu_tab_cons([],[]).
treu_tab_cons([_,C|R],[C|R1]):-
	treu_tab_cons(R,R1),!.


reconstrueix(S,T,Demo,Cons,Tabini):-
	reconst(Tabini,S,T,Demo,_,[],Cons),!.

reconst(_,_,_,[1,0|Demo],Demo,C,C):-!.
reconst(K,S,T,[1,N|Demo],DOut,C,COut):-!,
	S=..[_|ArgsS],
	elem(N,ArgsS,Sub),
	reconst(K,Sub,T,Demo,DOut,C,COut),!.
reconst(K,S,T,[2|Demo],DOut,C,[K,S>T|COut]):-
	T=..[_|ArgsT],
	map(list2,S,ArgsT,Parelles),
	K1 is K+2,
	reconst_per_parelles(K1,Parelles,Demo,DOut,C,COut),!.
reconst(K,S,T,[3,0|Demo],Demo,C,[K,S>=T|C]):-
	statuslex,!.			%3,0 quan trets iguals a la dreta no queda res
reconst(K,S,T,[3,N|Demo],DOut,C,[K,S>=T|COut]):-
	statuslex,!,			%3,num_arg_>,demo,llista_args_queden (no =),demo
	S=..[_|ArgsS], 
	elem(N,ArgsS,SubS),
	T=..[_|ArgsT],
	elem(N,ArgsT,SubT),
	K1 is K+2,
	reconst(K1,SubS,SubT,Demo,D1,C,C1),
	D1=[L|D2],
	((L=[],!,DOut=D2,COut=C1)
	 ;
	 (selec_elems(L,ArgsT,SubtsT),
	  map(list2,S,SubtsT,Parelles),
	  reconst_per_parelles(K1,Parelles,D2,DOut,[],C2),
	  concat312(C1,C2,COut)
	 )
	),!.
reconst(K,S,T,[3|Demo],DOut,C,[K,S>=T|COut]):-
	S=..[_|ArgsS], T=..[_|ArgsT],
	difer(ArgsT,ArgsS,ArgsTS),!,
	length21(ArgsTS,Q),
	K1 is K+2,
	aplicar_cas3(K1,Q,ArgsS,ArgsT,Demo,DOut,C,COut),!.


%%%%%%%%%%%%%%%%%%%%%%%
% pel cas 2

reconst_per_parelles(_,[],Demo,Demo,C,C):-!.
reconst_per_parelles(K,[[S,T]|Parelles],Demo,DOut,C,COut):-
	reconst(K,S,T,Demo,D1,C,C1),
	reconst_per_parelles(K,Parelles,D1,DOut,[],C2),!,
	concat312(C1,C2,COut),!.


%%%%%%%%%%%%%%%%%%%%%%%
% pel cas 3

aplicar_cas3(_,0,_,_,D,D,C,C):-!.
aplicar_cas3(K,M,ArgsS,ArgsT,[N1,N2|Demo],DOut,C,COut):-
	elem(N1,ArgsS,SubS),
	elem(N2,ArgsT,SubT),
	reconst(K,SubS,SubT,Demo,D1,C,C1),
	M1 is M-1,
	aplicar_cas3(K,M1,ArgsS,ArgsT,D1,DOut,[],C2),!,
	concat312(C1,C2,COut),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mostra([]):-!.
mostra([N,C|Rest]):-
	tab(N),
	write(C),nl,
	mostra(Rest),!.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% diversos missatges, mostrar intrpo trobat i mostrar RPO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

miss_no(1,S,T):-
	write('The rule '),
	write(S),write(' -> '),write(T),nl,
	write(' cannot be proved terminating.'),nl.

miss_si(1):-
	write('Is a trivial constraint.'),nl,nl.
miss_si(2):-
	write('This constraint does not produce any cycle with a strict pair.'),nl.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

show_strat:-
	innermost,!,
	write('=========== Proving  INNERMOST  termination ==========='),nl,nl.
show_strat.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

show_RPO([],[]):- !,
        write('with RPO with the empty precedence'),nl.
show_RPO(P,[]):- !,
        write('with RPO with the precedence:'),nl,
        write_list(P),nl.
show_RPO([],S):- !,
        write('with RPO with the empty precedence and the status:'),nl,
        write_list(S),nl.
show_RPO(P,S):- !,
        write('with RPO with the precedence:'),nl,
        write_list(P),nl,
        write('and the status:'),nl,
        write_list(S),nl.


show_const(Rules,Const):-
	nl,write('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),nl,
	write('The final constraint is composed of:'),nl,nl,
	write('Constraints from the rules:'),nl,
	write_list(Rules),nl,
	write('Constraints to prove every cycle is well-founded:'),nl,
	( (Const=[],nl,nl) ; write_list(Const) ),!.

show_result(Ints,Prec,Stat):-
	write('The constraint is satisfied by combining the interpretation:'),nl,
 	write_Ints(Ints),nl,
        show_RPO(Prec,Stat),!.


show_result_Set_cancel(Rules,[[N,C,[I,P,S]]]):-!,
	show_const_cancel(Rules,N,C),nl,
	show_result(I,P,S),!.

show_const_cancel(C_Rules,[],C_Const):-
	show_const(C_Rules,C_Const),!.
show_const_cancel(C_Rules,NewRules,C_Const):-
	show_const(C_Rules,C_Const),
	write('Constraints which eliminate cycles:'),nl,
	write_list(NewRules),nl.



transformInt(F,0,[1],F,F):-!.
transformInt(F,Ar,[X|Int],S,T):-
	crearlistIN(1,Ar,L),
	map(give_name0,L,L1),
	S=..[F|L1], selvarsInt(Int,L1,L2),
	((X=0, L2=[T])
	  ;
	 (X=1, T=..[F|L2])),!.

selvarsInt([0|R],[_|R1],R2):-!,
	selvarsInt(R,R1,R2),!.
selvarsInt([1|R],[X|R1],[X|R2]):-!,
	selvarsInt(R,R1,R2),!.
selvarsInt([],[],[]):-!.

write_Ints([]):-!.
write_Ints([[F,Ar,IntF]|Ints]):-
	transformInt(F,Ar,IntF,S,T),!,
	write(S),write('|->'),write(T),nl,
	write_Ints(Ints),!.
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

show_message(['yes'],_):-write('Yes: The set of rules is null.'),nl,!.
show_message(['no'],Rules):-write('The following set of rules cannot be proved terminating:'),nl,nl,nl,
		write_Rules(Rules),nl,!.
show_message(['nomod'],Rules):-
	write('The following set of rules cannot be proved terminating.'),
	        nl,nl,nl,	
		write_Rules(Rules),nl,!.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

show_result_rpo(Rules,Prec,Stat):-
	write('The TRS :'),nl,nl,
	write_Rules(Rules),nl,nl,	
	write('can be proved terminating'),nl,
	show_RPO(Prec,Stat),nl,!.


write_Rules([]):-!.
write_Rules([[]|Rest]):-
	nl,write('    * * *'),nl,nl, 
	write_Rules(Rest),!.
write_Rules([[L,R]|Rest]):-
	write('    '), write(L), write(' -> '), write(R),nl,
	write_Rules(Rest),!.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


