%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% others.pl 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ordre_mspo(Rules,Kind,nomod):-
	( ( interactive, try_ordre(Rules,_,Kind) )
	  ;
	  (\+interactive, try_ordre(Rules,n,Kind) )
	),
	clean_end,!.
ordre_mspo(Rules,File,Kind,nomod):-
	tell(File),
	try_ordre(Rules,n,Kind),
	clean_end,!,
	told.

try_ordre(Rules,H,Kind):-
	ordre(Rules,Resultat,H,Kind,Proof),!,
	show_strat,
	mostrar_demostracio(Rules,Proof,Resultat),!.
try_ordre(_,_,_).
	


%%%%%%%%%%

ordre_mspo(Rules,Kind,disjConS):-	
	( ( interactive, try_modBasic(Rules,_,Kind) )
	  ;
	  (\+interactive, try_modBasic(Rules,n,Kind) )
	),
	clean_end,!.
ordre_mspo(Rules,File,Kind,disjConS):-
	tell(File),
	try_modBasic(Rules,n,Kind),
	clean_end,!,
	told.

try_modBasic(Rules,H,Kind):-
	modBasic(Rules,Resultat,H,Kind,Proof),!,
	show_strat,
	mostrar_demostracio(Rules,Proof,Resultat),!.
try_modBasic(_,_,_).

%%%%%%%%%%

ordre_mspo(Rules,Kind,hier):-	
	( ( interactive, try_mod(Rules,_,Kind) )
	  ;
	  (\+interactive, try_mod(Rules,n,Kind) )
	),
	clean_end,!.
ordre_mspo(Rules,File,Kind,hier):-
	tell(File),
	try_mod(Rules,n,Kind),
	clean_end,!,
	told.

try_mod(Rules,H,Kind):-
	mod(Rules,Resultat,H,Kind,Proof),!,
	show_strat,
	mostrar_demostracio(Rules,Proof,Resultat),!.
try_mod(_,_,_).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Per utilitzar directament RPO 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

rpo(Rules):-
	( ( interactive, try_rpoterm1(Rules,_) )
	  ;
	  (\+interactive , try_rpoterm1(Rules,n) )
	),
	clean_end,!.	
rpo(Rules,File):-
	tell(File),
	try_rpoterm1(Rules,n),!,
	clean_end,	
	told.

try_rpoterm1(Rules,H):-
	rpoterm1(Rules,Prec,Stat,H),!,
	renvars_list1(Rules,Rules1),
	show_result_rpo(Rules1,Prec,Stat),!.
try_rpoterm1(_,_).
	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

rpoterm1([],[],[],_):-!.
rpoterm1(Rules,PrecOut,StatOut,H):-
	inici(Rules),
	prepare_rpo1(Rules,C_Rules,Prec,Stat,H),
	proof_rpo(C_Rules,Prec,Stat,PrecOut,StatOut),!.

proof_rpo(C_Rules,Prec,Stat,PrecOut,StatOut):-
	try_rpo(C_Rules,Prec,Stat,PrecOut,StatOut),!.
proof_rpo(_,_,_,_,_):-	
	write('The set of rules cannot be proved terminating with RPO.'),
	nl,!,fail.
	
prepare_rpo1(Rules,C_Rules,Prec,Stat,Help):-
	renvars_list1(Rules,Rules1),
	convert_rules_rpo(Rules1,C_Rules),
	assertz(renamed([])),   
	ask_help_rpo(C_Rules,Help),
	inic_rpo(Help,Prec,Stat),!.


convert_rules_rpo([],[]):-!.
convert_rules_rpo([[L,R]|Rest],[L>R|Rest1]):-
	convert_rules_rpo(Rest,Rest1),!.


ask_help_rpo(_,Help):- nonvar(Help),!.
ask_help_rpo(Rules,Help):-
	write_list(Rules),
	write('Do you want to give any information?'),nl,
	obtain_answer(Help),!.

inic_rpo(n,[],[]):-!.
inic_rpo(y,Prec,Stat):-
	obtain_symbols(Lsymbs),
	obtain_status(Lsymbs,Stat0),
	obtain_prec(Lsymbs,Stat0,Stat,Prec).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Conversi format regles i cicles i
%  entrada informaci per part de l'usuari per int_rpo : Prec,Stat,Inter
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

prepare_int_rpo(C_Rules,C_Const,Prec,Stat,Inter,Help0):-
	obtain_renamed_tops(C_Const,Ren),
	retractall(renamed(_)),
	assertz(renamed(Ren)),   
	retractall(ajuda2(_)),
	ask_help(Help0,C_Rules,C_Const,Help),
	inic_components(Help,Prec,Stat,Inter),!.

prepare_int_rpo(C_Rules,New_Rules,C_Const,RulesOut,Prec,Stat,Inter,Help0):-
	obtain_renamed_tops(C_Const,Ren),
	retractall(renamed(_)),
	assertz(renamed(Ren)),   
	retractall(ajuda2(_)),
	set_new_defined(New_Rules),
	concat312(C_Rules,New_Rules,RulesOut),
	ask_help(Help0,RulesOut,C_Const,Help),
	inic_components(Help,Prec,Stat,Inter),!.

convert_rules_const([],[]):-!.
convert_rules_const([[L,R]|Rules],[L>=R|C_Rules]):-
	convert_rules_const(Rules,C_Rules),!.
%cal perque quan modularitat introdueixo [] per separar sistemes
convert_rules_const([[]|Rules],C_Rules):-
	convert_rules_const(Rules,C_Rules),!.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ask_help0(Help0):- nonvar(Help0),!.
ask_help0(Help0):- ajuda(Help0),!.
ask_help0(Help0):-
	write('Do you want to give information before proving every constraint?'),nl,
	obtain_answer(Help0),
	assertz(ajuda(Help0)),!.

ask_help(n,_,_,n):-!,
	assertz(ajuda2('n')),!.
ask_help(y,Rules,Const,Help):-
	show_const(Rules,Const),
	write('Do you want to give any information?'),nl,
	obtain_answer(Help),
	assertz(ajuda2(Help)),!.

obtain_answer(Help):-
	read(H), ok_answer(H,Help),!.
obtain_answer(Help):-
	write('Please enter y/n: '),
	obtain_answer(Help),!.	

ok_answer(H,y):-member212(H,[y,yes,s,si]),!.
ok_answer(H,n):-member212(H,[n,no]),!.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

inic_components(n,[],[],[]):-!.
inic_components(y,Prec,Stat,Inter):-
	obtain_components(Prec,Stat,Inter),!.

obtain_components(Prec,Stat,Inter):-
	obtain_symbols(Lsymbs),
	obtain_status(Lsymbs,Stat0),
	obtain_prec(Lsymbs,Stat0,Stat,Prec),
	obtain_inter(Lsymbs,Inter),!.

obtain_symbols(Lsymbs):-
	leftR(Def),
	noleftR(Cons),
	renamed(Ren),
	concat312(Def,Cons,L),
	concat312(L,Ren,Lsymbs),!.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

check_ground_list([X|R]):-
	\+(ground([X|R])),!,
	miss_gr_l(1),!,fail.
check_ground_list(R):- islist(R),!.
check_ground_list(_):- 
	miss_gr_l(2),!,fail.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
obtain_status(Lsymbs,Stat):-
	nl,write('If you do not want to fix something enter emptyset []'),nl,nl,
	obtain_stat(multiset,Multiset),	
	format_and_check_stat(Lsymbs,mul,Multiset,[],Stat1),
	obtain_stat(lexicographic(left-to-right),Lex_l_to_r),	
	format_and_check_stat(Lsymbs,lex,Lex_l_to_r,Stat1,Stat2),
	obtain_stat(lexicographic(right-to-left),Lex_r_to_l),	
	format_and_check_stat(Lsymbs,lexr,Lex_r_to_l,Stat2,Stat).
obtain_status(Lsymbs,Stat):-
	nl,write('Enter the status again'),nl,
	obtain_status(Lsymbs,Stat),!.

%%%%%%%%%%%%%%%%%%%%%
obtain_stat(Stat,S):-
	write('Please enter the list of symbols with '),
	write(Stat), write(' status'),nl,
	read(St), check_ground_list(St),
	sort(St,S),!.
obtain_stat(Stat,S):- obtain_stat(Stat,S).

%%%%
format_and_check_stat(_,_,[],Stat,Stat):-!.
format_and_check_stat(Lsymbs,StatSymbs,[F|Rest],Stat,StatOut):-
	member21([F,_],Lsymbs),!,
	check_and_format_stat(F,StatSymbs,Stat,Stat1),
	format_and_check_stat(Lsymbs,StatSymbs,Rest,Stat1,StatOut),!.
format_and_check_stat(Lsymbs,StatSymbs,[F|Rest],Stat,StatOut):-
	mis_symb(1,F),!,continue,
	format_and_check_stat(Lsymbs,StatSymbs,Rest,Stat,StatOut),!.

check_and_format_stat(F,_,Stat,Stat):-
	member21([F,S],Stat),!,
	mis_stat(1,F,S),!,continue.
check_and_format_stat(F,StatF,Stat,[[F,StatF]|Stat]):-!.
	

%%%%%%%%%%%%%%%%%%%%
obtain_prec(Lsymbs,Stat,StatOut,PrecOut):-
	nl,write('Please enter the precedence or emptyset([])'),nl,
	read_prec(P),
	format_and_check_prec(Lsymbs,P,Stat,StatOut,[],PrecOut),!.
obtain_prec(Lsymbs,Stat,StatOut,PrecOut):-
	mis_prec(1),nl,
	write('Enter de precedence again.'),!,nl,
	obtain_prec(Lsymbs,Stat,StatOut,PrecOut),!.
	

format_and_check_prec(_,[],Stat,Stat,Prec,Prec):-!.
format_and_check_prec(_,Prec,_,_,_,_):-
	member22(F>F,Prec),!,fail.
format_and_check_prec(Lsymbs,[P|Rest],Stat,StatOut,Prec,PrecOut):-
	P=..[Op|_], operOK(Op),!,
	f_and_check_prec(P,Lsymbs,Rest,Stat,StatOut,Prec,PrecOut),!.
format_and_check_prec(Lsymbs,[P|Rest],Stat,StatOut,Prec,PrecOut):-
	mis_symb(2,P),!, continue,
	format_and_check_prec(Lsymbs,Rest,Stat,StatOut,Prec,PrecOut),!.

f_and_check_prec(P,Lsymbs,Rest,Stat,StatOut,Prec,PrecOut):-
	P=..[_|[F,G]],
	member21([F,_],Lsymbs),
	member21([G,_],Lsymbs),!,
	check_and_format_prec(P,Stat,Stat1,Prec,Prec1),
	format_and_check_prec(Lsymbs,Rest,Stat1,StatOut,Prec1,PrecOut),!.
f_and_check_prec(P,Lsymbs,Rest,Stat,StatOut,Prec,PrecOut):-
	mis_symb(3,P),!, continue,
	format_and_check_prec(Lsymbs,Rest,Stat,StatOut,Prec,PrecOut),!.


	
read_prec(P):-
	read(P1), check_ground_list(P1),sort(P1,P),!.
read_prec(P):- 
	write('Enter de precedence again.'),!,nl,
	read_prec(P).


operOK('>').
operOK('=').
operOK('>=').

%%%%
check_and_format_prec(P,Stat,StatOut,Prec,PrecOut):-
	generarF(P,Prec,PrecOut,Stat,StatOut),!.



%%%%%%%%%%%%%%%%%%%
obtain_inter(Lsymbs,Inter):-
	nl,write('Please enter the interpretation of the symbols with the following format:'),nl,
	write('[[Symbol,Int_symbol],...] where Int_symbol is a list of 0s and 1s'),nl,
	write('The first 1/0 indicates selection/not selection of the head.'),nl,
	write('The rest indicates the selection(1) or not selection(0) of every subterm'),nl,
	write('For instance [[f,[1,0,1,1]],[g,[0,0,1]]] means'),nl, 
	write('I(f(x,y,z))=f(y,z) and I(g(x,y))=y'),nl,
	read(Int), check_ground_list(Int),
	sort(Int,Int1), 
	format_and_check_inter(Lsymbs,Int1,[],Inter),!.
obtain_inter(Lsymbs,Inter):-
	write('Enter de interpretation again.'),!,nl,
	obtain_inter(Lsymbs,Inter),!.

format_and_check_inter(_,[],Inter,Inter):-!.
format_and_check_inter(_,[[F,IntF]|_],Inter0,_):-
	member21([F,IntF0],Inter0),!,\+(IntF=IntF0),
	mis_inter(1,F),!,fail.
format_and_check_inter(Lsymbs,[[F,IntF]|_],_,_):-
	member21([F,Ar],Lsymbs),
	length21(IntF,L), \+(L is Ar+1),!, 
	mis_inter(2,F,Ar),!,fail.
format_and_check_inter(Lsymbs,[[F,IntF]|Int],Inter0,Inter):-
	member21([F,Ar],Lsymbs),!,
	check_inter_ok(F,IntF),!,
	format_and_check_inter(Lsymbs,Int,[[F,Ar,IntF]|Inter0],Inter).
format_and_check_inter(_,[[F,_]|_],_,_):-
	mis_inter(5,F),!,fail.
format_and_check_inter(_,_,_,_):-
	mis_inter(6),!,fail.

check_inter_ok(F,[0|R]):-
	sum(R,N), \+(N=1),!,
	mis_inter(3,F),!,fail.
check_inter_ok(F,Int):-
	member21(X,Int),
	\+(X=0), 
	\+(X=1),!,
	mis_inter(4,F),!,fail.
check_inter_ok(_,_):-!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
miss_gr_l(1):- 
	write('A variable is not allowed.'),nl,!.
miss_gr_l(2):- 
	write('Bad format. A list is expected. '),nl,!.



mis_symb(1,F):- 
	write('The symbol '), write(F), write(' does not appears in the TRS.'),nl,
	write('The symbol will be ignored'),nl,!.
mis_symb(2,P):- 
	write('Error: The allowed operators are >, >= or = '),nl,
	write(P),
	write('  will be ignored'),nl,!.
mis_symb(3,P):- 
	write('A symbol in '), write(P), write(' does not appears in the TRS.'),nl,
	write(P),
	write('  will be ignored'),nl,!.


mis_stat(1,F,S):- 
	write('The symbol '), write(F), write(' has '),
	write(S), write(' status.'), nl.

mis_prec(1):-
	write('This precedence is not well-founded.'),nl.

mis_inter(1,F):-
	write('The symbol '), write(F), write(' has several interpretations.'),nl,!.

mis_inter(2,F,Ar):-
	write('The arity of the symbol '), write(F), 
	write(' is '), write(Ar),nl,!.

mis_inter(3,F):-
	write('The interpretations for '), write(F),
	write(' is not valid'),nl,!.

mis_inter(4,F):-
	write('The interpretations for '), write(F),
	write('is not valid'),!.
 
mis_inter(5,F):- 
	write('The symbol '), write(F), write(' does not appears in the TRS.'),nl,!.

mis_inter(6):- 
	write('Bad format. '),!.


continue:-
	write('Do you agree(y/n)? '), obtain_answer(Cont),!, Cont='y',!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

